<?php
/*Álvaro Millán Serrano*/

namespace App\controllers;
use App\Models\Purchase;
use App\Models\Movie;
use Controller;
use App\Controllers\CustomerController;
use Core\Validation;

use Pagerfanta\Adapter\ArrayAdapter;
use Pagerfanta\Pagerfanta;


class PurchaseController{

    public static function showPurchases($args){
        CustomerController::index();
        $customerUser = unserialize($_SESSION['customer']);

        if(isset($args[1])){
            $message = "Tickets purchased successfully";
        }

        $purchases = Purchase::all($customerUser->idCustomer);
        $pages = Purchase::purchasePages($customerUser->idCustomer);

        $adapter = new ArrayAdapter($purchases);
        $pagerfanta = new Pagerfanta($adapter);
        $pagerfanta = Pagerfanta::createForCurrentPageWithMaxPerPage($adapter, $pages, 3);

        $currentPageResults = $pagerfanta->getCurrentPageResults();
        $page = $pagerfanta->getNbPages();

        require "../app/views/purchaseTable.php";

    }

    public function buy($args){
        CustomerController::index();
        $customerUser = unserialize($_SESSION['customer']);

        $movie = Movie::findMovie($args[0]);
        require "../app/views/purchaseTickets.php";
    }

    public function transaction(){
        Validation::sessionTimer();
        if(!isset($_SESSION['customer'])){
            header("location: /customer/login");
        }
        $customerUser = unserialize($_SESSION['customer']);

        $purchaseError = "";

        $purchaseError = Validation::validatePurchase($_POST["ticketQuantity"]);

        $movieID = $_POST["movieID"];
        $movie = Movie::findMovie($movieID);


        if($purchaseError === ""){


            $movieTickets = $_POST["ticketQuantity"];

            if($movie->tickets >= $movieTickets && $movie->tickets > 0){
                $purchaseValidator = Purchase::findByCustomerMovie($movie->idMovie, $customerUser->idCustomer);
                if(empty($purchaseValidator)){
                    $purchase = Purchase::create($customerUser->idCustomer, $movie->idMovie, $movieTickets);
                    if($purchase){
                        Movie::substractTickets($movie->idMovie, $movie->tickets, $movieTickets);
                        header("location: /purchase/showPurchases/1/success");
                    }
                }else{
                    $purchaseError = "You have already bought seats for this movie";
                }
            }else{
                $purchaseError = "There aren't enough seats";
            }
        }
        require "../app/views/index.php";
        require "../app/views/purchaseTickets.php";

    }



}
