<?php
/*Álvaro Millán Serrano*/

namespace App\Models;

use Core\Model;
use PDO;

class Purchase extends Model{

    public static function all($id){
        $db = self::connection();

        $stmt = $db->prepare("SELECT m.name, p.numTickets, p.date 
                                        FROM purchases p
                                        JOIN movies m  ON p.idMovie = m.idMovie
                                        WHERE idCustomer = :idCustomer");

        $stmt->bindParam(":idCustomer", $id, PDO::PARAM_INT);

        $stmt->execute();
        $purchases = $stmt->fetchAll(PDO::FETCH_OBJ);
        return $purchases;

    }

    public static function create($idCustomer, $idMovie, $numTickets){
        $db = self::connection();

        $stmt = $db->prepare("INSERT INTO purchases (idCustomer, idMovie, date, numTickets) 
                                        values (:idCustomer, :idMovie, :date, :numTickets)");

        $date  = date("Y-m-d");


        $stmt->bindParam(":idCustomer", $idCustomer, PDO::PARAM_INT);
        $stmt->bindParam(":idMovie", $idMovie, PDO::PARAM_INT);
        $stmt->bindParam(":date", $date);
        $stmt->bindParam(":numTickets", $numTickets, PDO::PARAM_INT);

        return $stmt->execute();

    }

   public static function findByCustomerMovie($idMovie, $idCustomer){
        $db = self::connection();
        $stmt = $db->prepare("SELECT * from purchases WHERE idMovie = :idMovie AND idCustomer = :idCustomer AND date = :date");

        $date = date("Y-m-d");

        $stmt->bindParam(":idMovie", $idMovie, PDO::PARAM_INT);
        $stmt->bindParam(":idCustomer", $idCustomer, PDO::PARAM_INT);
        $stmt->bindParam(":date", $date);

        $stmt->execute();
        $purchase = $stmt->fetch(PDO::FETCH_OBJ);

        return $purchase;

   }

   public static function purchasePages($idCustomer){
        $db = self::connection();
        $stmt = $db->prepare("SELECT COUNT(*) as row_count FROM purchases WHERE idCustomer = :idCustomer");
        $stmt->bindParam(":idCustomer", $idCustomer, PDO::PARAM_INT);

        $stmt->execute();
        $count = $stmt->fetch(PDO::FETCH_OBJ);
        $pages = $count->row_count/3;
        return $pages;
   }




}